package hu.unideb.ai.jars;

public class State {

	int[] a = new int[4];
	
	public static State start() {
		State start = new State();
		start.a[1] = 5;
		start.a[2] = 0;
		start.a[3] = 0;
		return start;
	}
	
	@Override
	public boolean equals(Object obj) {
		if ( obj == null || !( obj instanceof State) )
			return false;
		State arg = (State)obj;
		
		return this.a[1] == arg.a[1] && this.a[2] == arg.a[2] && this.a[3] == arg.a[3];
	}
	
	@Override
	public int hashCode() {
		return this.a[1]*100 + this.a[2]*10 + this.a[3];
	}
	
	@Override
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append('(').append(a[1]).append(',').append(a[2]).append(',').append(a[3]).append(')');
		return buffer.toString();
	}
	
	public boolean isGoal() {
		return a[1] == 4;
	}
	
	public double heur() {
		return Math.abs(4-a[1]);
	}
	
}
